// $Id: bonus.cc,v 1.7 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#include "bonus.h"




// *******************
// *** CONSTRUCTOR ***
// *******************
/*
FS::Bonus::Bonus(int _y, int _width, int _height, int _map_x, int _row,
        int _row_length_pixels, BonusType _bonus_type) : CollectableSprite(BONUS)
{
    y = _y;
    width = _width;
    height = _height;
    
    map_x = _map_x;
    row = _row;
    row_length_pixels = _row_length_pixels;
    
    my_bonus_type = _bonus_type;

    active = true;
    
    sprite_rect.y = y;
    sprite_rect.w = width;
    sprite_rect.h = height;
    
    dirty_rect.y = y;
    dirty_rect.h = height;
    
    coll_box_x_offset = COLL_BOX_X_OFFSET;
    coll_box_y_offset = COLL_BOX_Y_OFFSET;
    
    coll_box.w = COLL_BOX_WIDTH;
    coll_box.h = COLL_BOX_HEIGHT;
    
    bounding_box.w = width;
    bounding_box.h = height;
    
} // FS::Bonus::Bonus()
*/
        
FS::Bonus::Bonus( int _x, int _y, int _my_row, BonusType _my_bonus_type )
{
    x = old_x = _x;
    y = old_y = _y;
    width = CELL_WIDTH;
    height = CELL_HEIGHT;
    
    my_row = _my_row;
    my_bonus_type = _my_bonus_type;
    
    my_id = BONUS;
    
    sprite_dest_rect.y = y;
    
    erase_rect.y = y;
    erase_rect.w = width;
    erase_rect.h = height;
    
    update_rect.y = y;
    update_rect.h = height;
    
    coll_box_x_offset = BONUS_COLL_BOX_X_OFFSET;
    coll_box_y_offset = BONUS_COLL_BOX_Y_OFFSET;
    coll_box.w = BONUS_COLL_BOX_WIDTH; 
    coll_box.h = BONUS_COLL_BOX_HEIGHT;
    
    must_deactivate = false;
    active = true;
    
} // FS::Bonus::Bonus

// ******************
// *** DESTRUCTOR ***
// ******************
FS::Bonus::~Bonus()
{
    // ...
    
} // FS::Bonus::~Bonus()




// ************************
// *** MEMBER FUNCTIONS ***
// ************************

// **************************************************
/*
void FS::Bonus::update(const int * current_start_pixels, const int * pixels_to_move,
        const int * old_pixels_to_move, const Direction * directions,
        bool is_first_pass, PlayDisplay * pd)
{
    int pixels_moved = pixels_to_move[row] - old_pixels_to_move[row];
    
    calc_x(current_start_pixels[row]);
    calc_sprite_rect();
    
    // Initial values for dirty_rect.
    switch (directions[row])
    {
        case LEFT_TO_RIGHT:
            dirty_rect.x = x - pixels_moved;
            if (dirty_rect.x < 0)
            {
                dirty_rect.x += row_length_pixels;
            } // if
            
            dirty_rect.w = pixels_moved + width;
            
            break;
            
        case RIGHT_TO_LEFT:
            dirty_rect.x = x;
            
            dirty_rect.w = width + pixels_moved;
            
            break;
    } // switch
    
    update_visible = adjust_rect(&dirty_rect);
    
    if (sprite_visible)
    {
        pd->request_blit( ((ImageIDs) (my_bonus_type + IMAGE_ID_BONUS_OFFSET)), 
                NULL, &sprite_rect );
    } // if
    
    if (update_visible)
    {
        pd->request_update(dirty_rect);
    } // if   
    
} // FS::Bonus::update()
*/ 
// **************************************************

void FS::Bonus::update( const ScrollingData & sd )
{
    // Need to scroll whether bonus's active or not - it will
    // be reactivated if the level is restarted.
    scroll_x(sd);   // i.e. MapSprite::scroll_x
    
    if ( active )
    {
        if ( calc_rects(sd, my_row) )   // see CollectableSprite::calc_rects
        {
            if ( !must_deactivate )
            {
                my_blitter->request_blit_image( 
                        (GfxStore::Image_Name) (my_bonus_type + 32),   // FIXME!!!
                        sprite_dest_rect );
            } 
            else
            {
                must_deactivate = false;
                deactivate();   // see Sprite::deactivate
            } // if ... else
        } // if
    } // if
    
} // FS::Bonus::update

// **************************************************

void FS::Bonus::reset()
{
    active = true;
    must_deactivate = false;
    
} // FS::Bonus::reset

// **************************************************

