// $Id: bonus.h,v 1.9 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _BONUS_H_
#define _BONUS_H_




#include "collectablesprite.h"
#include "constants.h"
#include "enums.h"
#include "gfxstore.hh"
#include "blitter.hh"




extern FS::GfxStore * my_gfx;
extern FS::Blitter * my_blitter;




namespace FS
{
    
class Bonus : public CollectableSprite
{
    private:

        BonusType my_bonus_type;
        int points; // this is only used for TREATs
    
    public:
            
        //Bonus(int _y, int _width, int _height, int _map_x, int _row,
        //        int _row_length_pixels, BonusType _bonus_type);
        Bonus( int _x, int _y, int _my_row, BonusType _my_bonus_type );
        ~Bonus();
        
        //void update(const int * current_start_pixels, const int * pixels_to_move,
        //        const int * old_pixels_to_move, const Direction * directions,
        //        bool is_first_pass, PlayDisplay * pd);
        
        // Provide implementation of pure virtual function in MapSprite.
        void update( const ScrollingData & sd );
        
        void reset();
        
        BonusType get_bonus_type() const { return my_bonus_type; }
        
}; // class Bonus

} // namespace FS




#endif
    
