// $Id: collectablesprite.cc,v 1.7 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#include "collectablesprite.h"




// *******************
// *** CONSTRUCTOR ***
// *******************
/*
FS::CollectableSprite::CollectableSprite(CS_ID id)
{
    my_id = id;
    
} // FS::CollectableSprite::CollectableSprite()
*/
FS::CollectableSprite::CollectableSprite() {}
        
// ******************
// *** DESTRUCTOR ***
// ******************
FS::CollectableSprite::~CollectableSprite()
{
    // ...
    
} // FS::CollectableSprite::~CollectableSprite()




// ************************
// *** MEMBER FUNCTIONS ***
// ************************

// **************************************************

bool FS::CollectableSprite::calc_rects( const ScrollingData & sd, int row )
{
    // For the purposes of the following code, x-coord should
    // be < SCREEN_WIDTH. For want of a better name, we'll call this
    // value virtual_x, because it's the 'onscreen' value as used by SDL.
    int virtual_x;
    int virtual_old_x;
    
    if ( x >= SCREEN_WIDTH )
    {
        virtual_x = -(sd.row_lengths_in_pixels[row] - x);
    }
    else
    {
        virtual_x = x;
    } // if ... else
    
    if ( old_x >= SCREEN_WIDTH )
    {
        virtual_old_x = -(sd.row_lengths_in_pixels[row] - old_x);
    }
    else
    {
        virtual_old_x = old_x;
    } // if ... else
    
    // y, w and h fields in sprite_dest_rect are constant.
    sprite_dest_rect.x = virtual_x;
    
    sprite_visible = sprite_dest_rect.x + width >= 0;
    
    return sprite_visible;
    
} // FS::CollectableSprite::calc_rects

// **************************************************
// **************************************************
// **************************************************
// **************************************************
// **************************************************
