// $Id: collectablesprite.h,v 1.7 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _COLLECTABLESPRITE_H_
#define _COLLECTABLESPRITE_H_




#include "mapsprite.h"




namespace FS
{
    
class CollectableSprite : public MapSprite
{
    public:
        
        enum CS_ID { CRYSTAL, BONUS };
    
    protected:
            
        CS_ID my_id;
        bool must_deactivate;
        
    public:
        
        //CollectableSprite(CS_ID id);
        CollectableSprite();
        virtual ~CollectableSprite();
        
        CS_ID get_id() const { return my_id; }
        
        // Calculates sprite_dest_rect, erase_rect and, if appropriate,
        // update_rect, as well as setting erase_rect_visible and
        // sprite_visible. Returns true if sprite needs drawing and/or
        // erasing; otherwise false.
        bool calc_rects( const ScrollingData & sd, int row );
        
        // FIXME: make Sprite::deactivate virtual and redefine here to add extra?
        void set_must_deactivate() { must_deactivate = true; } 
        void deactivate() { active = false; must_deactivate = true; }
                
        virtual void reset() = 0;
        
}; // CollectableSprite

} // namespace FS




#endif

        
