// $Id: crystal.h,v 1.8 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _CRYSTAL_H_
#define _CRYSTAL_H_




#include "collectablesprite.h"
#include "enums.h"
#include "constants.h"
#include "gfxstore.hh"
#include "blitter.hh"




extern FS::GfxStore * my_gfx;
extern FS::Blitter * my_blitter;




namespace FS
{
    
class Crystal : public CollectableSprite
{
    private:
         
        CrystalColor original_color;
        CrystalColor current_color;
        
    public:
    
        Crystal( int _x, int _y, int _my_row, CrystalColor color );
        ~Crystal();
        
        CrystalColor get_color() const { return current_color; }
        void set_color(CrystalColor cc) { current_color = cc; }
        void reset();
        
        // Provide implementation of pure virtual function in MapSprite.
        void update( const ScrollingData & sd );
        
}; // class Crystal

} // namespace FS




#endif

                
