// $Id: fish.cc,v 1.7 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#include "fish.h"




// *******************
// *** CONSTRUCTOR ***
// *******************
FS::Fish::Fish()
{
    x = FISH_X;
    y = FISH_Y;
    width = FISH_WIDTH;
    height = FISH_HEIGHT;
    
    sprite_dest_rect.x = FISH_X;
    sprite_dest_rect.y = FISH_Y;
    
    update_rect.x = FISH_X;
    update_rect.y = FISH_Y;
    update_rect.w = FISH_WIDTH;
    update_rect.h = FISH_HEIGHT;
    
    // Need these two values for Sprite::get_coll_box()
    // to work properly.
    //sprite_rect.x = FISH_X;
    //sprite_rect.y = FISH_Y;
    
    coll_box_x_offset = COLL_BOX_X_OFFSET;
    coll_box_y_offset = COLL_BOX_Y_OFFSET;
            
    coll_box.w = COLL_BOX_WIDTH;
    coll_box.h = COLL_BOX_HEIGHT;
    
    bounding_box.w = width;
    bounding_box.h = height;
    
} // FS::Fish::Fish()

// ******************
// *** DESTRUCTOR ***
// ******************
FS::Fish::~Fish()
{
    // nothing yet
    
} // FS::Fish::~Fish()




// ************************
// *** MEMBER FUNCTIONS ***
// ************************

// **************************************************

void FS::Fish::draw(/*PlayDisplay * pd*/)
{
    //pd->request_erase(&dirty_rect);
    //pd->request_blit( ((fish_taken) ? PLATE : FISH), NULL, &dest_rect );
    //pd->request_update(dirty_rect);
    my_blitter->request_erase( GfxStore::BACKGROUND, update_rect );
    my_blitter->request_blit_image( 
            ((fish_taken) ? GfxStore::PLATE : GfxStore::FISH), sprite_dest_rect );
    my_blitter->request_update(update_rect);
    
} // FS::Fish::draw()

// **************************************************

void FS::Fish::reset()
{
    fish_taken = false;
    
} // FS::Fish::reset();

// **************************************************

void FS::Fish::remove_fish()
{
    fish_taken = true;
    
} // FS::Fish::remove_fish()

// **************************************************
// **************************************************
// **************************************************     
