// $Id: fish.h,v 1.9 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _FISH_H_
#define _FISH_H_




#include "sprite.h"
#include "constants.h"
#include "SDL.h"
#include "enums.h"
#include "gfxstore.hh"
#include "blitter.hh"




extern FS::GfxStore * my_gfx;
extern FS::Blitter * my_blitter;




namespace FS
{
    
class Fish : public Sprite
{
    private:
            
        static const int COLL_BOX_X_OFFSET = 5;
        static const int COLL_BOX_Y_OFFSET = 9;
        static const int COLL_BOX_WIDTH = 38;
        static const int COLL_BOX_HEIGHT = 19;
        
        //SDL_Rect dest_rect;
        //SDL_Rect dirty_rect;
        
        bool fish_taken;
        
    public:
        Fish();
        ~Fish();
        
        void reset();
        
        void draw(/*PlayDisplay * pd*/);
        void remove_fish();
        
}; // class Fish

} // namespace FS




#endif

    
