// $Id: gamemanager.h,v 1.16 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _GAMEMANAGER_H_
#define _GAMEMANAGER_H_




#include "SDL.h"
#include "gametimer.h"
#include "titlescreendisplay.h"
#include "playmodel.h"
#include "getreadydisplay.h"
#include "enums.h"
#include "soundengine.h"
#include "highscoresdisplay.h"
#include "settings.h"
#include "settingsdisplay.h"
#include "userinput.hh"
#include <iostream>




extern FS::UserInput * my_input;
extern FS::Mode current_mode;



namespace FS
{

class GameManager
{
    public:
        enum State { INTRO, SELECTING_START_LEVEL, GET_READY, PLAY, 
                SETTINGS, HI_SCORES, ENTERING_NAME };
        
        static const int MAX_EVENTS = 10;
        
    private:
        GameTimer timer;    
        TitleScreenDisplay ts_display;
        PlayModel p_model;
        GetReadyDisplay gr_display;
        SoundEngine snd_engine;
        HighScoresDisplay hs_display;
        Settings my_settings;
        SettingsDisplay s_display;
        
        State current_state;
        bool loop_running;
        
        void handle_selection(TitleScreenDisplay::Selection sel);
        
    public:
        GameManager();
        ~GameManager();
        
        void start_loop();
        
}; // class GameManager

} // namespace FS




#endif
    
