// $Id: gametimer.h,v 1.7 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _GAME_TIMER_H_
#define _GAME_TIMER_H_




#include "SDL.h"




class GameTimer
{
    private:
        int start_time;    
        int num_ticks_on_pause;        
        bool running;

    public:
        GameTimer();
        ~GameTimer();

        // Returns true if timer running after 'pause', else false.
        bool pause();        
        bool is_running() const { return running; }        
        int get_time() const;
        
        // Simply forces timer to run if it's paused.
        void resume();
        
}; // class GameTimer




#endif

