// $Id: getreadydisplay.h,v 1.12 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _GETREADYDISPLAY_H_
#define _GETREADYDISPLAY_H_




#include "SDL.h"
#include "enums.h"
#include "userinput.hh"
#include "gfxstore.hh"
#include "blitter.hh"




extern FS::UserInput * my_input;
extern FS::GfxStore * my_gfx;
extern FS::Blitter * my_blitter;
extern SDL_Surface * screen;




namespace FS
{
    
class GetReadyDisplay
{
    private:
        static const int SECONDS_TO_WAIT = 10;
    
        //SDL_Surface * screen;   // from GameManager
        
        SDL_Rect dest_rect;
        SDL_Rect erase_rect;
        
        int start_time;
        
        int current_start_level;
    
    public:
        GetReadyDisplay(/*SDL_Surface * s*/);
        ~GetReadyDisplay();
        
        void start_draw(int gt, int lev);
        
        // Returns true if ready to start game, otherwise false.
        bool redraw(int gt);
        
        void start_draw_level_select(int furthest_lev);
        
        // Returns chosen level if selected, else 0.
        int redraw_level_select(int furthest_lev);
        
}; // class GetReadyDisplay
    
} // namespace FS




#endif
    
