// $Id: mapsprite.h,v 1.7 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _MAPSPRITE_H_
#define _MAPSPRITE_H_




#include "sprite.h"
#include "enums.h"
#include "constants.h"




namespace FS
{
    
// This is an abstract class and therefore cannot be instantiated.
// You must provide derived classes with an implementation of the 
// update function if you want to create instances of those classes.
// In Fish Supper these classes are: Log, Crystal and Bonus.
    
class MapSprite : public Sprite
{    
    
    protected:
            
        int my_row;
        
        //bool adjust_rect(SDL_Rect * rect);

        //void calc_x(int current_start_pixel);
        //void calc_sprite_rect();
        
        // This is common to all scrolling sprites.
        void scroll_x( const ScrollingData & sd );
        
    public:
        MapSprite() {}
        virtual ~MapSprite() {}
        
        int get_row() const { return my_row; }
        
        // Pure virtual function makes MapSprite an abstract class.
        // Subclasses must provide a definition.
        /*
        virtual void update(const int * current_start_pixels, const int * pixels_to_move,
                const int * old_pixels_to_move, const Direction * directions, 
                bool is_first_pass, PlayDisplay * pd) = 0;
        */
        virtual void update( const ScrollingData & sd ) = 0;
        
}; // class MapSprite

} // namespace FS




#endif

        
          
