// $Id: pausemenu.h,v 1.7 2009-01-25 09:29:46 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _PAUSE_MENU_H_
#define _PAUSE_MENU_H_




#include "enums.h"
#include "userinput.hh"
#include "SDL.h"
#include "blitter.hh"
#include "gfxstore.hh"




extern FS::UserInput * my_input;
extern FS::Blitter * my_blitter;




namespace FS
{
    
class PauseMenu
{
    public:
            
        enum PauseMenuSelection { PMS_NONE, PMS_CONTINUE, PMS_QUIT };
    
    private:
            
        PauseMenuSelection current_selection;
        SDL_Rect menu_update_rect;
        
    public:
            
        PauseMenu();
        ~PauseMenu();
        
        void reset();
        PauseMenuSelection update();
        void draw();
        void erase();
        
        // FIXME: this is a hack - we're just getting PauseMenu to
        // do PlayModel's dirty work for it. When pause type is
        // PAUSE_AUTO (see PlayModel), call this function to see if
        // 'jump' has been pressed (and gobble up any other events).
        bool has_pressed_jump() const;
        
}; // class PauseMenu
    
} // namespace FS




#endif

