// $Id: scroller.hh,v 1.3 2009-01-25 09:29:47 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _SCROLLER_HH_
#define _SCROLLER_HH_




#include "constants.h"
#include "enums.h"
#include <fstream>
#include <string>




namespace FS
{

class Scroller
{

    public:
            
        
        
    private:
            
        ScrollingData my_data;
        Cell my_cells[NUM_ROWS][MAX_COLS];

        void reset_cells();
        
    public:

        Scroller();
        ~Scroller();
        
        void load_data(std::ifstream & fin);
        void halve_velocity(int row) { my_data.current_velocities[row] /= 2; }
        void double_velocity(int row) { my_data.current_velocities[row] *= 2; }
        void change_direction(int row);
        void restore_original_directions_and_velocities();
        void update(int t);
        const Cell * get_row_of_cells(int row) const { return my_cells[row]; }
        const ScrollingData & get_data() const { return my_data; }

}; // class Scroller

} // namespace FS




#endif
