// $Id: titlescreendisplay.h,v 1.14 2009-01-25 09:29:47 matthew Exp $

// Fish Supper
// Copyright 2006, 2007, 2009 Matthew Clarke <matthew_larcke@lycos.co.uk>

// This file is part of Fish Supper.

// Fish Supper is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Fish Supper is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Fish Supper.  If not, see <http://www.gnu.org/licenses/>.




#ifndef _TITLE_SCREEN_DISPLAY_H_
#define _TITLE_SCREEN_DISPLAY_H_




#include "SDL.h"
#include "userinput.hh"
#include "gfxstore.hh"
#include "blitter.hh"
#include <iostream>
#include <string>




extern FS::UserInput * my_input;
extern FS::GfxStore * my_gfx;
extern FS::Blitter * my_blitter;




namespace FS
{
    
class TitleScreenDisplay
{
    public:
        static const int NUM_SELECTIONS = 5;
        enum Selection { PLAY, TUTORIAL, SETTINGS, HI_SCORES, QUIT, NONE };
    
    private:
        static const int SELECTION_X = 450;
        std::string selection_names[NUM_SELECTIONS];
        SDL_Rect selection_rects[NUM_SELECTIONS];
        
        // Of type 'int' because you can't ++/-- an 'enum' type.
        int current_selection;
        int old_selection;
        
        void redraw_selection();
        
    public:
        TitleScreenDisplay();
        ~TitleScreenDisplay();  
        
        void start_draw();  
        Selection update();
        
}; // class TitleScreenDisplay
        
} // namespace FS




#endif
     
